# -*- encoding: cp932 -*-e
#!/usr/bin/env python

#-------------- User changable settings are in configuration.py --------------

#------------------------------ System Imports -------------------------------
from __future__ import generators

import pdb
import sys, os
"""
if not hasattr(sys, 'frozen'):
    v = '2.6'
    import wxversion
    if '--unicode' in sys.argv:
        wxversion.ensureMinimal(v+'-unicode', optionsRequired=True)
    elif '--ansi' in sys.argv:
        wxversion.ensureMinimal(v+'-ansi', optionsRequired=True)
    else:
        wxversion.ensureMinimal(v)
"""
DEBUG = '--debug' in sys.argv
USE_THREAD = '--nothread' not in sys.argv

#macro: unfinished
MACROS = '--macros' in sys.argv
PRINTMACROS = 0

def _restart(orig_path=os.getcwd(), orig_sysargv=sys.argv[:]):
    os.chdir(orig_path)
    args = [sys.executable] + orig_sysargv
    if len(cf.spawnargs) == 1:
        _ = args.pop(0)
    
    os.execvp(args[0], args + ['--last'])

sys.argv = [i for i in sys.argv if i not in ('--ansi', '--unicode', '--debug', '--nothread', '--macros')]

import stat
import keyword, traceback, cStringIO, imp, fnmatch, re
import time, pprint
from wxPython.wx import *
from wxPython.stc import *
from wxPython.lib.rcsizer import RowColSizer
from wxPython.lib.dialogs import wxScrolledMessageDialog
import wx.lib.mixins.listctrl as listctrl
wxListCtrlAutoWidthMixin, wxColumnSorterMixin, wxTextEditMixin = \
  listctrl.ListCtrlAutoWidthMixin, listctrl.ColumnSorterMixin, listctrl.TextEditMixin
import copy
import inspect
import textwrap
import md5
import compiler
import Queue
import threading
import wx
import wx.stc as stc

if DEBUG:
    from wx.py import crust

EFFECTUAL_NORMCASE = os.path.normcase('AbCdEf') == 'abcdef'
UNICODE = wxUSE_UNICODE

#--------------------------- configuration import ----------------------------
import configuration as cf
from parsers import *
#---------------------------- Event Declarations -----------------------------
"""
"""

class cancelled(Exception):
        pass

#unicode BOM stuff
if 1:
    BOM = [('+/v8-', 'utf-7'),
          ('\xef\xbb\xbf', 'utf-8'),
          ('\xfe\xff', 'utf-16-be'),
          ('\xff\xfe\xff\xfe', 'utf-16'),
          ('\xff\xfe', 'utf-16-le'),
          ('', 'ascii'),
          ('', 'other')]
    ADDBOM = {}
    ENCODINGS = {}
    for i,j in BOM:
        ADDBOM[j] = i
        ENCODINGS[j] = wxNewId()
    del i;del j;

#menu preferences
if 1:
    MENULIST = []
    MENUPREF = {}
    OLD_MENUPREF= {}
    HOTKEY_TO_ID = {}

    def _spl(n):
        return (n.split('\t', 1) + [''])[:2]

    def recmenu(menu, id):
        #this was a pain in the ass.
        if isinstance(menu, wxMenuItem) or isinstance(menu, wxMenuItemPtr):
            sm = menu.GetSubMenu()
            if sm:
                a = recmenu(sm, id)
                if a:
                    return '%s->%s'%(menu.GetLabel(), a)
                return ''
            elif menu.GetId() == id:
                return menu.GetLabel()
            else:
                return ''
        elif isinstance(menu, wxMenu) or isinstance(menu, wxMenuPtr):
            ITEMS = menu.GetMenuItems()
            for i in ITEMS:
                a = recmenu(i, id)
                if a:
                    return a
            return ''
        else:
            for i in xrange(menu.GetMenuCount()):
                r = menu.GetMenu(i)
                if r.FindItemById(id):
                    return "%s->%s"%(menu.GetLabelTop(i), recmenu(r, id))
        raise Exception("Item not found.")
    
    def GETACC(X):
        if len(X) == 3:
            return X
        return X[0], X[1], X[1]
    
    def menuAdd(root, menu, name, desc, funct, id, kind=wxITEM_NORMAL):

        a = wxMenuItem(menu, id, 'TEMPORARYNAME', desc, kind)
        menu.AppendItem(a)
        EVT_MENU(root, id, funct)

        ns, oacc = _spl(name)
        hier = recmenu(menuBar, id)[:-13] + ns
        if hier in MENUPREF:
            name, acc, acc2 = GETACC(MENUPREF[hier])
        else:
            if hier in OLD_MENUPREF:
                name, acc, acc2 = MENUPREF[hier] = GETACC(OLD_MENUPREF[hier])
            else:
                name, acc, acc2 = MENUPREF[hier] = GETACC((ns, oacc))

        MENULIST.append((hier, name, oacc, acc, kind in [wxITEM_NORMAL, wxITEM_CHECK], acc2))
        ## if type(acc) != type(acc2):
            ## acc2 = acc2.decode('latin-1')
        ## if acc != acc2:
            ## print "mismatched hotkey: %r %r"%(acc, acc2)

        if acc or acc2:
            HOTKEY_TO_ID[acc2] = id

        menuBar.SetLabel(id, '%s\t%s'%(name, acc))
        menuBar.SetHelpString(id, desc)

    def menuAddM(parent, menu, name, help=''):
        if isinstance(parent, wxMenu) or isinstance(parent, wxMenuPtr):
            id = wxNewId()
            parent.AppendMenu(id, "TEMPORARYNAME", menu, help)
            hier = recmenu(menuBar, id) + name
            name, toss, toss2 = MENUPREF[hier] = GETACC(MENUPREF.get(hier, (name, '')))

            menuBar.SetLabel(id, name)
            menuBar.SetHelpString(id, help)
        else:
            hier = name
            name, toss, toss2 = MENUPREF[hier] = GETACC(MENUPREF.get(hier, (name, '')))

            parent.Append(menu, name)

        MENULIST.append((hier, name, '', toss, 0, toss2))

    def getIcon():
        data = cf.getData()
        stream = cStringIO.StringIO(data)
        image = wxImageFromStream(stream)
        bitmap = wxBitmapFromImage(image)
        icon = wxEmptyIcon()
        icon.CopyFromBitmap(bitmap)
        return icon


#findbar ids
if 1:

    pypeID_DELETE = wxNewId()
    pypeID_FINDBAR = wxNewId()
    pypeID_REPLACEBAR = wxNewId()
    pypeID_TOGGLE_BOOKMARK = wxNewId()
    pypeID_NEXT_BOOKMARK = wxNewId()
    pypeID_PRIOR_BOOKMARK = wxNewId()

"""
"""
if True:
    #cursor behavior ids
    CARET_ID_TO_OPTIONS = {
        wxNewId()        : (0, wxSTC_CARET_EVEN|wxSTC_CARET_SLOP|wxSTC_CARET_STRICT, 1, "Margin Respecting", "Caret is at least M lines from the top and bottom, N*M pixels from the right and left"),
        wxNewId()        : (1, wxSTC_CARET_EVEN|wxSTC_CARET_STRICT, 4, "Centered", "Caret is centered on the display, if possible"),
        wxNewId()        : (2, wxSTC_CARET_STRICT, 3, "Top Attached", "Caret is always on the top line, if possible"),
        wxNewId()        : (3, wxSTC_CARET_SLOP|wxSTC_CARET_STRICT, 2, "Margin Attached", "Caret is always M lines from the top, and N*M pixels from the right, if possible"),
        wxNewId()        : (4, wxSTC_CARET_EVEN, 0, "PyPE Classic", "Caret is at least 1 line from the top and bottom, 10 pixels from the right and left"),
    }

    CARET_OPTION_TO_ID = dict([(j[0], (i, j[1])) for i,j in CARET_ID_TO_OPTIONS.iteritems()])
    
    #bookmark support
    BOOKMARKNUMBER = 1
    BOOKMARKSYMBOL = wxSTC_MARK_CIRCLE
    BOOKMARKMASK = 2



# ====================================================================================================
class PythonSTC(wxStyledTextCtrl):
    def __init__(self, notebook, ID, parent):
        wxStyledTextCtrl.__init__(self, parent, ID)#, style = wxNO_FULL_REPAINT_ON_RESIZE)
        self.SetWordChars('abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ')
        self.SetEndAtLastLine(False)
        self.cached = None
        self.MarkerDefine(BOOKMARKNUMBER, BOOKMARKSYMBOL, 'blue', 'blue')

        #pdb.Pdb().set_trace()
        # _ ͎̂Ă邽߂ damie ϐ
        #_, flags = CARET_OPTION_TO_ID[caret_option]
        _, flags = CARET_OPTION_TO_ID[0]
        #self.SetXCaretPolicy(flags, caret_slop*caret_multiplier)
        #self.SetYCaretPolicy(flags, caret_slop)
        self.SetXCaretPolicy(flags, 10*20)
        self.SetYCaretPolicy(flags, 10)

        self.hierarchy = []
        self.kw = []
        self.tooltips = {}
        self.ignore = {}

        self.parent = parent
        #self.notebook = notebook #should also be equal to self.parent.parent
        self.root = parent  #self.root = self.notebook.root
        self.sloppy = 0
        self.smartpaste = 0
        self.dirty = 0
        self.refresh = 0
        self.lexer = 'text'
        self.selep = None
        self.recording = 0
        self.macro = []

        self.format = cf.eol   # kVz 06.12.07;configuration.eol: end of line used by OS
        self.enc = 'utf-8'  # kVz 06.12.07; Ƃ肠 utf8 ɐݒ肵ĂĂ݂

        #Text is included in the original, but who drags text?  Below for dnd file support.
        #if dnd_file: self.SetDropTarget(FileDropTarget(self.root))

        #for command comlpetion
        self.SetKeyWords(0, " ".join(keyword.kwlist))

        self.SetMargins(0,0)
        self.SetViewWhiteSpace(False)
        self.SetBackSpaceUnIndents(1)
        #self.SetBufferedDraw(False)
        #self.SetViewEOL(True)

        self.SetMarginType(0, wxSTC_MARGIN_NUMBER)
        #self.StyleSetSpec(wxSTC_STYLE_LINENUMBER, "size:%(size)d,face:%(mono)s" % faces)

        # Setup a margin to hold fold markers
        #I agree, what is this value?
        #self.SetFoldFlags(16)  ###  WHAT IS THIS VALUE?  WHAT ARE THE OTHER FLAGS?  DOES IT MATTER?

        self.SetProperty("fold", "1")
        self.SetMarginType(2, wxSTC_MARGIN_SYMBOL)
        self.SetMarginMask(2, wxSTC_MASK_FOLDERS)
        self.SetMarginSensitive(2, True)
        self.SetMarginWidth(2, 12)

        if cf.collapse_style: # simple folder marks, like the old version
            self.MarkerDefine(wxSTC_MARKNUM_FOLDER, wxSTC_MARK_BOXPLUS, "navy", "white")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDEROPEN, wxSTC_MARK_BOXMINUS, "navy", "white")
            # Set these to an invisible mark
            self.MarkerDefine(wxSTC_MARKNUM_FOLDEROPENMID, wxSTC_MARK_BACKGROUND, "white", "black")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDERMIDTAIL, wxSTC_MARK_BACKGROUND, "white", "black")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDERSUB, wxSTC_MARK_BACKGROUND, "white", "black")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDERTAIL, wxSTC_MARK_BACKGROUND, "white", "black")

        else: # more involved "outlining" folder marks
            self.MarkerDefine(wxSTC_MARKNUM_FOLDEREND,     wxSTC_MARK_BOXPLUSCONNECTED,  "white", "black")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDEROPENMID, wxSTC_MARK_BOXMINUSCONNECTED, "white", "black")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDERMIDTAIL, wxSTC_MARK_TCORNER,  "white", "black")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDERTAIL,    wxSTC_MARK_LCORNER,  "white", "black")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDERSUB,     wxSTC_MARK_VLINE,    "white", "black")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDER,        wxSTC_MARK_BOXPLUS,  "white", "black")
            self.MarkerDefine(wxSTC_MARKNUM_FOLDEROPEN,    wxSTC_MARK_BOXMINUS, "white", "black")


        # Make some styles,  The lexer defines what each style is used for, we
        # just have to define what each style looks like.  This set is adapted from
        # Scintilla sample property files.

        #And good wxPython users who have seen some demos know the above was copied
        #and pasted, along with a lot of sample code, right out of the demo.  The
        #demo r0XX0rs.

        """
        # Global default styles for all languages
        self.StyleSetSpec(wxSTC_STYLE_DEFAULT,     "fore:#000000,face:%(mono)s,back:#FFFFFF,size:%(size)d" % faces)
        self.StyleSetSpec(wxSTC_STYLE_LINENUMBER,  "back:#C0C0C0,face:Lucida Console,size:%(size2)d" % faces)
        self.StyleSetSpec(wxSTC_STYLE_CONTROLCHAR, "face:%(other)s" % faces)
        self.StyleSetSpec(wxSTC_STYLE_BRACELIGHT,  "fore:#003000,face:%(mono)s,back:#80E0E0"% faces)
        self.StyleSetSpec(wxSTC_STYLE_BRACEBAD,    "fore:#E0FFE0,face:%(mono)s,back:#FF0000"% faces)
        """
        font = wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 
                faceName="lr SVbN", encoding=wx.FONTENCODING_CP932 )
        self.SetFont(font)

        #various settings
        self.SetSelBackground(1, '#B0B0FF')

        #again, some state variables
        self.filename = ''
        self.dirname = ''
        self.opened = 0
        self.AutoCompStops(' .,;:()[]{}\'"\\<>%^&+-=*/|`')

        EVT_STC_UPDATEUI(self,    ID, self.OnUpdateUI)
        EVT_STC_MARGINCLICK(self, ID, self.OnMarginClick)
        #EVT_KEY_DOWN(self, self.root.OnKeyPressed)     # 07.01.14 Kvł
        EVT_KEY_DOWN(self, self.OnKeyPressed)     # 07.01.14 Kvł
        #EVT_CHAR(self, self.root.OnKeyPressed)
        EVT_KEY_UP(self, self.key_up)

        EVT_STC_CHARADDED(self, ID, self.added)
        EVT_STC_CHANGE(self, ID, self.cha)
        #unavailable in 2.5.1.2, didn't work in previous versions of wxPython
        # EVT_STC_POSCHANGED(self, ID, self.pos)
        EVT_STC_SAVEPOINTREACHED(self, ID, self.MakeClean)
        EVT_STC_SAVEPOINTLEFT(self, ID, self.MakeDirty)
        EVT_STC_NEEDSHOWN(self, ID, self.OnNeedShown)
        self.Bind(EVT_STC_MACRORECORD, self.GotEvent)
        self.SetModEventMask(wxSTC_MOD_INSERTTEXT|wxSTC_MOD_DELETETEXT|wxSTC_PERFORMED_USER|wxSTC_PERFORMED_UNDO|wxSTC_PERFORMED_REDO)

        if cf.REM_SWAP:
            self.CmdKeyClear(ord('T'), wxSTC_SCMOD_CTRL)

        self.CmdKeyClear(ord('Z'), wxSTC_SCMOD_CTRL)
        self.CmdKeyClear(ord('Y'), wxSTC_SCMOD_CTRL)
        self.CmdKeyClear(ord('X'), wxSTC_SCMOD_CTRL)
        self.CmdKeyClear(ord('C'), wxSTC_SCMOD_CTRL)
        self.CmdKeyClear(ord('V'), wxSTC_SCMOD_CTRL)
        self.CmdKeyClear(ord('A'), wxSTC_SCMOD_CTRL)
    
    def StopRecord(self):
        wxStyledTextCtrl.StopRecord(self)
        #macro: merge all character 2170 events together
        macro = []
        last = []
        x = len(self.macro)
        for i in self.macro:
            if i[0] != 2170 or (i[0] == 2170 and isinstance(i[-1], (int, long))):
                if last:
                    macro.append((2170, 0, ''.join(last)))
                    last = []
                macro.append(i)
            else:
                last.append(i[-1])
        if last:
            macro.append(''.join(last))
        if len(macro) < x:
            self.macro = macro
            if PRINTMACRO: print "Reduced macro from %i to %i steps"%(x, len(macro))
    
    def _tdisable(self, fcn, *args, **kwargs):
        _, self.recording = self.recording, 0
        try:
            return fcn(*args, **kwargs)
        finally:
            self.recording = _
    
    def GotEvent(self, e):
        #macro: unfinished
        if self.recording:
            x = (e.GetMessage(), e.GetWParam(), e.GetLParam())
            if x[0] != 2170:
                self.macro.append(x)
            else:
                print "Couldn't handle unknown macro event:", x
            
    def PlayMacro(self):
        mlt = message_lookup_table
        #macro: unfinished
        ## self.BeginUndoAction()
        
        #macro: z represents generated code based on method name
        z = ['def macro(self, root):']
        if PRINTMACROS: print z[-1]
        for i in self.macro:
            m,w,l = i
            ## print i, 
            if m in mlt:
                method = getattr(self, mlt[m])
                z.append('    self.%s()'%mlt[m])
                method()
            elif isinstance(m, basestring):
                if l == None:
                    z.append("    root.keyboardShortcut(%r)"%m)
                    self.root.keyboardShortcut(m)
                else:
                    z.append("    root.Dent(None, %i)"%l)
                    self.root.Dent(None, l)
            elif m != 2170:
                #this branch should never be executed
                z.append("    message: %s"%m)
                self.SendMsg(m, w, l)
            elif isinstance(l, (int, long)):
                z.append("    root._autoindent(self)")
                self.root._autoindent(self)
            else:
                z.append("    self.ReplaceSelection(%r)"%l)
                self.ReplaceSelection(l)
            if PRINTMACROS: print z[-1]
            wxYield()
            time.sleep(.01)
        ## self.EndUndoAction()
        print "Performed %s steps of the macro!"%len(self.macro)
        if PRINTMACROS: print '\n'.join(z)

    def pos(self, e):
        #print "position changed event"
        #for some reason I never get called
        self.pos_ch(e)

    def cha(self, e):
        #print "changed event"
        self.key_up(e)

    def save(self, e):
        #print "save reached"
        self.key_up(e)

    def savel(self, e):
        #print "save left"
        self.key_up(e)

    def key_up(self, e):
        if self.GetModify(): self.MakeDirty()
        else:                self.MakeClean()
        self.pos_ch(e)
        #e.Skip()
    
    def pos_ch(self, e):
        lin = self.GetCurrentLine()+1
        col = self.GetColumn(self.GetCurrentPos())
        self.root.SetStatusText("L%i C%i"%(lin, col), 1)

    def added(self, e):
        #pdb.Pdb().set_trace()
        
        #macro: unfinished
        if e and self.recording:
            self.macro.append((2170, 0, _decode_key(e.GetKey())))
            ## print "got key", repr(self.macro[-1][-1]), e.GetKey()
        
        try:
            full = e is None
            # trigger ̈ӖF낤ƂĂ̂ȂB
            #tr = self.triggers
            c = 0
            gcp = self.GetCurrentPos()
            for p in xrange(gcp-1, -1, -1):
                if not full and p < gcp-1:
                    break
                ch = self.GetCharAt(p)
                if UNICODE:
                    ch = (chr((ch>>8)&255)+chr(ch&255)).decode('utf-16-be')
                else:
                    ch = chr(ch)
                c += 1
                break   # 06.10.09 trigger Ӗ̂Ȃ̂Ŏ荇苎
                """
                tr = tr.get(ch, None)
                if tr is None:
                    ## print "ran off of triggers!", ch, gcp-p-1
                    break
                elif type(tr) is tuple:
                    self.SetSelection(p, p+c)
                    self.ReplaceSelection(tr[0])
                    p += len(tr[0])
                    self.SetSelection(p,p)
                    self.InsertText(p, tr[1])
                    break
                """
        finally:
            self.key_up(e)
    
    def jump(self, direction):
        #1 forward, -1 backward
        if direction not in (1,-1):
            return

        #set up characters
        chars2, chars3 = '({[:,\'"', ')}]\'"'
        if self.GetLexer() in (wxSTC_LEX_HTML, wxSTC_LEX_XML):
            chars2 = chars2 + '>'
            chars3 = chars3 + '<'
        #chars2 are things that we want to be to the right of
        #chars3 are things that we want to be to the left of
        chars1 = chars2 + chars3
        
        #cursor position information
        linenum = self.GetCurrentLine()
        pos = self.GetCurrentPos()
        
        #iterator setup
        if direction == 1:
            it = xrange(pos, self.GetTextLength())
        else:
            it = xrange(pos-1, -1, -1)
        
        #updates information cross-lines
        for p in it:
            ch = self.GetTextRange(p, p+1)
            if ch not in chars1:
                continue
            
            if direction == 1: #if we are heading to the right
                #if we want to be to the right of line[p], make it so
                if ch in chars2:
                    p += 1
                    break
                #else if this character is just to the right of where we are at, skip it
                elif p == pos:
                    continue
                #else if we want to be to the left of line[p], make it so
                elif ch in chars3:
                    break
            else: #else we are heading to the left
                #if we want to be to the left of line[p], make it so
                if ch in chars3:
                    break
                #else if this character is just to the left of where we are at, skip it
                elif p == pos-1:
                    continue
                #else if we want to be to the right of line[p], make it so
                elif ch in chars2:
                    p += 1
                    break
            
        else:
            return
        self._tdisable(self.SetSelection, p, p)

#------------------------- persistant document state -------------------------
    def GetSaveState(self):
        BM = []
        FOLD = []
        """ # kVz 06.12.27
        if self.GetParent().IsSplit():
            self.GetParent().GetWindow2().savePreferences()
        """
        ret =  {'BM':BM,
                'FOLD':FOLD,
                'use_tabs':self.GetUseTabs(),
                'spaces_per_tab':self.GetTabWidth(),
                'indent':self.GetIndent(),
                'marker_margin':bool(self.GetMarginWidth(1)),
                'line_margin':bool(self.GetMarginWidth(0)),
                'col_line':self.GetEdgeColumn(),
                'col_mode':self.GetEdgeMode(),
                'indent_guide':self.GetIndentationGuides(),
                'showautocomp':self.showautocomp,
                'wrapmode':self.GetWrapMode(),
                ## 'sortmode':self.tree.tree.SORTTREE,
                'save_cursor':self.save_cursor,
                'cursor_posn':self.GetCurrentPos(),
                'findbarprefs':self.findbarprefs,
                'triggers':self.triggers,
                'whitespace':self.GetViewWhiteSpace(),
                'sloppy':self.sloppy,
                'smartpaste':self.smartpaste,
                'checksum':md5.new(self.GetText()).hexdigest()
               }
        for line in xrange(self.GetLineCount()):
            if self.MarkerGet(line) & BOOKMARKMASK:
                BM.append(line)

            if (self.GetFoldLevel(line) & wxSTC_FOLDLEVELHEADERFLAG) and\
            (not self.GetFoldExpanded(line)):
                FOLD.append(line)
        FOLD.reverse()
        return ret

    def SetSaveState(self, saved):
        self.SetUseTabs(saved['use_tabs'])
        self.SetProperty("tab.timmy.whinge.level", "10"[bool(saved['use_tabs'])])
        self.SetTabWidth(saved['spaces_per_tab'])
        self.SetIndent(saved['indent'])
        self.SetMarginWidth(0, 40*saved['line_margin'])
        self.SetMarginWidth(1, 16*saved['marker_margin'])
        #self.SetEdgeColumn(saved['col_line'])
        self.SetEdgeMode(saved['col_mode'])
        self.SetIndentationGuides(saved['indent_guide'])
        self.showautocomp = saved['showautocomp']
        self.findbarprefs = dict(saved.get('findbarprefs', {}))
        self.triggers = dict(saved['triggers'])
        self.sloppy = saved['sloppy']
        self.smartpaste = saved['smartpaste']
        if self.GetWrapMode() != saved['wrapmode']:
            self.root.WrapToggle(self)
        ## self.tree.tree.SORTTREE = saved.get('sortmode', sortmode)
        self.save_cursor = saved['save_cursor']
        for bml in saved.get('BM', []):
            self.MarkerAdd(bml, BOOKMARKNUMBER)
        for exl in saved.get('FOLD', []):
            a = self.GetLastChild(exl, -1)
            self.HideLines(exl+1,a)
            self.SetFoldExpanded(exl, 0)

        try: wxYield()
        except: pass

        if self.save_cursor:
            a = saved.get('cursor_posn', 0)
            self.SetSelection(a,a)
            self.EnsureCaretVisible()
            self.ScrollToColumn(0)

#-------------------- fix for SetText for the 'dirty bit' --------------------
    def SetText(self, txt, emptyundo=1):
        self.SetEOLMode(cf.fmt_mode[self.format])
        self.enc = 'ascii'
        if UNICODE:
            for bom, enc in BOM:
                if txt[:len(bom)] == bom:
                    self.enc = enc
                    txt = txt[len(bom):]
                    #print "chose", enc
                    break
            if self.enc == 'ascii':
                twolines = txt.split(self.format, 2)[:2]
                for line in twolines:
                    x = re.search('coding[=:]\s*([-\w.]+)', line)
                    if not x:
                        continue
                    x = x.group(1).lower()
                    if x in ADDBOM:
                        self.enc = x
                        break
                    else:
                        self.enc = 'other'
                        try:
                            txt = txt.decode(x)
                        except Exception, why:
                            self.root.dialog(('''\
                                You have used %r as your encoding
                                declaration, but PyPE was unable to decode
                                your document due to:
                                %s
                                PyPE will load your document as ASCII.
                                Depending on the content of your file, this
                                may cause data loss if you save the opened
                                version.  You do so at your own risk, and
                                have now been warned.'''%(x, why)).replace(32*' ', ''),
                                "%r decoding error"%why)
                            self.enc = 'ascii'
                        break
            if self.enc not in ('ascii', 'other'):
                try:
                    txt = txt.decode(self.enc)
                except Exception, why:
                    #print "failed text decoding"
                    self.root.dialog(('''\
                        There has been a unicode decoding error:
                        %s
                        To prevent loss or corruption of data, it
                        is suggested that you close the document,
                        do not save.  Then try to open the document
                        with the application you originally created
                        it with.  If PyPE was the original creator,
                        and only editor of the document, please
                        contact the author and submit a bug report.'''%(why)).replace(24*' ', ''),
                        "Unicode decoding error.")
                    self.enc = 'ascii'
        wxStyledTextCtrl.SetText(self, txt)
        self.ConvertEOLs(cf.fmt_mode[self.format])
        self.opened = 1
        if emptyundo:
            self.EmptyUndoBuffer()
            self.SetSavePoint()

    def GetText(self):
        self.ConvertEOLs(cf.fmt_mode[self.format])
        if UNICODE:
            if self.enc == 'other':
                txt = wxStyledTextCtrl.GetText(self)
                twolines = txt.split(self.format, 2)[:2]
                x = None
                #pull the encoding
                for line in twolines:
                    x = re.search('coding[=:]\s*([-\w.]+)', line)
                    if not x:
                        continue
                    x = str(x.group(1).lower())
                    break
                #try the encoding, ascii, then utf-8 in that order
                why = None
                for i in [j for j in (x, 'ascii', 'utf-8') if j]:
                    try:
                        txt = txt.encode(i)
                    except UnicodeEncodeError, wh:
                        if why is None:
                            why = wh
                    else:
                        if x != None and x != i:
                            y = os.path.join(self.dirname, self.filename)
                            if self.root.dialog(('''\
                                    While trying to save the file named:
                                        %s
                                    PyPE was not able to encode the file as specified in the encoding declaration as:
                                        %r
                                    Due to:
                                        %s
                                    Would it be all right for PyPE to instead use %r as an encoding?
                                    '''%(y, x, why, i)).replace(36*' ', ''),
                                    "Continue with alternate encoding?", wxYES_NO) != wxID_YES:
                                raise cancelled
                            self.root.SetStatusText("Using %r encoding for %s"%(i, y))
                        return ADDBOM.get(i, '') + txt
            if self.enc == 'ascii':
                try:
                    return wxStyledTextCtrl.GetText(self).encode(self.enc)
                except:
                    #Previously non-unicode ascii file has had unicode characters
                    #inserted.  Must encode into some sort of unicode format.
                    #I choose you, utf-8!
                    self.enc = 'utf-8'
                    self.root.SetStatusText(self.enc, 2)
                    """' kVz 06.12.28
                    if self.root.HAS_RADIO:
                        self.root.menubar.Check(ENCODINGS[self.enc], 1)
                    '"""
            return ADDBOM.get(self.enc, '') + wxStyledTextCtrl.GetText(self).encode(self.enc)
        return wxStyledTextCtrl.GetText(self)

#----- Takes care of the little '*' modified next to the open file name ------
    def MakeDirtyKvz(self, e=None):
        if (not self.dirty) and self.opened:
            self.dirty = 1
            f = self.filename
            if f == ' ':
                f = 'untitled.txt'
            self.SetTitle(f)
        if e:
            e.Skip()

    def MakeDirty(self, e=None):
        if (not self.dirty) and self.opened:
            self.dirty = 1
            """'    # kVz 06.12.28
            f = self.filename
            if f == ' ':
                f = '<untitled %i>'%self.NEWDOCUMENT
            c = 0
            for i in self.notebook:
                if i == self:
                    break
                c += 1
            self.notebook.SetPageText(c, '* '+f)
            self.root.redrawvisible(self)
            '"""
        if e:
            e.Skip()

    def MakeClean(self, e=None):
        if self.dirty:
            self.dirty = 0
            f = self.filename
            if f == ' ':
                f = '<untitled %i>'%self.NEWDOCUMENT
            c = 0
            """'    # kVz 06.12.28
            for i in self.notebook:
                if i == self:
                    break
                c += 1
            self.notebook.SetPageText(c, f)
            '"""
            self.SetSavePoint()
            #self.root.redrawvisible(self)  # kVz 06.12.28
        if e:
            e.Skip()


    def nada(self, e):
        pass

    def do(self, funct, dirty=1):
        if dirty:
            self.MakeDirty(None)
        funct(self)
        self.root.redrawvisible(self)
    def SelectLines(self):
        x,y = self.GetSelection()
        if x==y:
            return
        lnstart = self.LineFromPosition(x)
        lnend = self.LineFromPosition(y-1)
        
        if lnstart == lnend:
            return
        start = self.PositionFromLine(lnstart)
        end = self.GetLineEndPosition(lnend)
        self.SetSelection(start, end)
    def Cut(self):
        if self.sloppy and not self.SelectionIsRectangle():
            self.SelectLines()
        self.do(wxStyledTextCtrl.Cut)
    def Copy(self):
        if self.sloppy and not self.SelectionIsRectangle():
            self.SelectLines()
        self.do(wxStyledTextCtrl.Copy, 0)
    def Paste(self):
        if self.recording:
            self.macro.append((2179, 0, 0))
        while self.smartpaste:
            x,y = self.GetSelection()
            if x != y:
                break
            d = GetClipboardText()
            if d is None or '\n' not in d:
                break
            
            self.BeginUndoAction()
            #create a new line using the auto-indent stuff
            curline = self.LineFromPosition(x)
            x = self.GetLineEndPosition(curline)
            self.SetSelection(x,x)
            if self.GetLineIndentation(curline)+self.PositionFromLine(curline) != x:
                self._tdisable(self.root._autoindent, self)
            
            #sanitize the information to be pasted
            lines = d.replace('\r\n', '\n').replace('\r', '\n').split('\n')
            
            #find the leading indentation for the clipboard text
            tabwidth = self.GetTabWidth()
            repl = tabwidth*' '
            x = []
            z = len(d)
            for line in lines:
                leading_whitespace = line[:len(line)-len(line.lstrip())]
                rest = line[len(leading_whitespace):]
                leading_whitespace = leading_whitespace.replace('\t', repl)
                llw = len(leading_whitespace)
                if not rest.strip():
                    llw = z
                x.append((llw, leading_whitespace, rest))
            
            #reindent the clipboard text
            base = self.GetLineIndentation(self.LineFromPosition(self.GetSelection()[0]))*' '
            min_i = min(x)[0]
            usetabs = self.GetUseTabs()
            out = []
            for y, (li, lw, lr) in enumerate(x):
                lw = lw[min_i:]
                if y:
                    ## print "non-first line", lr
                    lw = base + lw
                if usetabs:
                    lw = lw.replace(repl, '\t')
                out.append(lw+lr)
            
            x = self.format.join(out)
            #insert the clipboard text
            self.ReplaceSelection(x)
            self.EndUndoAction()
            return
                
        self.do(wxStyledTextCtrl.Paste)
    def DeleteSelection(self):   self.do(wxStyledTextCtrl.DeleteBack)
    def Undo(self):     self.do(wxStyledTextCtrl.Undo)
    def Redo(self):     self.do(wxStyledTextCtrl.Redo)
    def CanEdit(self):
        return 1
#--------- Ahh, the style change code...isn't it great?  Not really. ---------
    def changeStyle(self, stylefile, language):
        try:
            #from StyleSupport import initSTC
            ## from STCStyleEditor import initSTC
            from StyleSetter import initSTC
            initSTC(self, stylefile, language)
            ## self.SetLexer(wxSTC_LEX_NULL)
            self.lexer = language
        except:
            
            #self.root.exceptDialog("Style Change failed, assuming plain text")
            self.root.SetStatusText("Style Change failed for %s, assuming plain text"%language)
            self.root.exceptDialog()
#----------------- Defaults, in case the other code was bad. -----------------
            #for some default font styles

            #self.SetLexer(wxSTC_LEX_NULL)
            self.lexer = 'text'

            ### Python styles
            ##
            ### White space
            ##self.StyleSetSpec(wxSTC_P_DEFAULT, "fore:#000000,face:%(helv)s,size:%(size)d" % faces)
            ### Comment
            ##self.StyleSetSpec(wxSTC_P_COMMENTLINE, "fore:#007F00,face:%(mono)s,back:#E0FFE0,size:%(size)d" % faces)
            ### Number
            ##self.StyleSetSpec(wxSTC_P_NUMBER, "fore:#007F7F,face:%(times)s,size:%(size)d" % faces)
            ### String
            ##self.StyleSetSpec(wxSTC_P_STRING, "fore:#7F007F,face:%(times)s,size:%(size)d" % faces)
            ### Single quoted string
            ##self.StyleSetSpec(wxSTC_P_CHARACTER, "fore:#7F007F,face:%(times)s,size:%(size)d" % faces)
            ### Keyword
            ##self.StyleSetSpec(wxSTC_P_WORD, "fore:#F0B000,face:%(mono)s,size:%(size)d,bold" % faces)
            ### Triple quotes
            ##self.StyleSetSpec(wxSTC_P_TRIPLE, "fore:#603000,face:%(times)s,back:#FFFFE0,size:%(size)d" % faces)
            ### Triple double quotes
            ##self.StyleSetSpec(wxSTC_P_TRIPLEDOUBLE, "fore:#603000,face:%(times)s,back:#FFFFE0,size:%(size)d" % faces)
            ### Class name definition
            ##self.StyleSetSpec(wxSTC_P_CLASSNAME, "fore:#0000FF,face:%(times)s,size:%(size)d,bold" % faces)
            ### Function or method name definition
            ##self.StyleSetSpec(wxSTC_P_DEFNAME, "fore:#0000FF,face:%(times)s,size:%(size)d,bold" % faces)
            ### Operators
            ##self.StyleSetSpec(wxSTC_P_OPERATOR, "face:%(times)s,size:%(size)d" % faces)
            ### Identifiers
            ##self.StyleSetSpec(wxSTC_P_IDENTIFIER, "fore:#000000,face:%(helv)s,size:%(size)d" % faces)
            ### Comment-blocks
            ##self.StyleSetSpec(wxSTC_P_COMMENTBLOCK, "fore:#7F7F7F,face:%(times)s,size:%(size)d" % faces)
            ### End of line where string is not closed
            ##self.StyleSetSpec(wxSTC_P_STRINGEOL, "fore:#000000,face:%(mono)s,back:#E0C0E0,eol,size:%(size)d" % faces)
            ##
            ##self.SetCaretForeground("BLACK")
            ##
            ### prototype for registering some images for use in the AutoComplete box.
            ###self.RegisterImage(1, images.getSmilesBitmap())
        font = wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 
                faceName="lr SVbN", encoding=wx.FONTENCODING_CP932 )
        self.SetFont(font)

#------------ copied and pasted from the wxStyledTextCtrl_2 demo -------------
    def OnUpdateUI(self, evt):
        # check for matching braces
        braceAtCaret = -1
        braceOpposite = -1
        charBefore = None
        caretPos = self.GetCurrentPos()
        if caretPos > 0:
            charBefore = self.GetCharAt(caretPos - 1)
            styleBefore = self.GetStyleAt(caretPos - 1)

        # check before
        if charBefore and chr(charBefore) in "[]{}()" and styleBefore == wxSTC_P_OPERATOR:
            braceAtCaret = caretPos - 1

        # check after
        if braceAtCaret < 0:
            charAfter = self.GetCharAt(caretPos)
            styleAfter = self.GetStyleAt(caretPos)
            if charAfter and chr(charAfter) in "[]{}()" and styleAfter == wxSTC_P_OPERATOR:
                braceAtCaret = caretPos

        if braceAtCaret >= 0:
            braceOpposite = self.BraceMatch(braceAtCaret)

        if braceAtCaret != -1  and braceOpposite == -1:
            self.BraceBadLight(braceAtCaret)
        else:
            self.BraceHighlight(braceAtCaret, braceOpposite)
            #pt = self.PointFromPosition(braceOpposite)
            #self.Refresh(True, wxRect(pt.x, pt.y, 5,5))
            #print pt
            #self.Refresh(False)

    def OnMarginClick(self, evt):
        # fold and unfold as needed
        if evt.GetMargin() == 2:
            lineClicked = self.LineFromPosition(evt.GetPosition())
            if self.GetFoldLevel(lineClicked) & wxSTC_FOLDLEVELHEADERFLAG:
                if evt.GetShift():
                    self.SetFoldExpanded(lineClicked, True)
                    self.Expand(lineClicked, True, True, 1)
                elif evt.GetControl():
                    if self.GetFoldExpanded(lineClicked):
                        self.SetFoldExpanded(lineClicked, False)
                        self.Expand(lineClicked, False, True, 0)
                    else:
                        self.SetFoldExpanded(lineClicked, True)
                        self.Expand(lineClicked, True, True, 100)
                else:
                    self.ToggleFold(lineClicked)

    def FoldAll(self):
        lineCount = self.GetLineCount()
        expanding = True

        # find out if we are folding or unfolding
        for lineNum in range(lineCount):
            if self.GetFoldLevel(lineNum) & wxSTC_FOLDLEVELHEADERFLAG:
                expanding = not self.GetFoldExpanded(lineNum)
                break;

        lineNum = 0
        while lineNum < lineCount:
            level = self.GetFoldLevel(lineNum)
            if level & wxSTC_FOLDLEVELHEADERFLAG and \
               (level & wxSTC_FOLDLEVELNUMBERMASK) == wxSTC_FOLDLEVELBASE:

                if expanding:
                    self.SetFoldExpanded(lineNum, True)
                    lineNum = self.Expand(lineNum, True)
                    lineNum = lineNum - 1
                else:
                    lastChild = self.GetLastChild(lineNum, -1)
                    self.SetFoldExpanded(lineNum, False)
                    if lastChild > lineNum:
                        self.HideLines(lineNum+1, lastChild)

            lineNum = lineNum + 1

    def Expand(self, line, doExpand, force=False, visLevels=0, level=-1):
        lastChild = self.GetLastChild(line, level)
        line = line + 1
        while line <= lastChild:
            if force:
                if visLevels > 0:
                    self.ShowLines(line, line)
                else:
                    self.HideLines(line, line)
            else:
                if doExpand:
                    self.ShowLines(line, line)

            if level == -1:
                level = self.GetFoldLevel(line)

            if level & wxSTC_FOLDLEVELHEADERFLAG:
                if force:
                    if visLevels > 1:
                        self.SetFoldExpanded(line, True)
                    else:
                        self.SetFoldExpanded(line, False)
                    line = self.Expand(line, doExpand, force, visLevels-1)

                else:
                    if doExpand and self.GetFoldExpanded(line):
                        line = self.Expand(line, True, force, visLevels-1)
                    else:
                        line = self.Expand(line, False, force, visLevels-1)
            else:
                line = line + 1;

        return line
#----------------------------- from Paul McNett ------------------------------
    def OnNeedShown(self, evt):
        """ Called when the user deletes a hidden header line."""
        # We expand the previously folded text, but it may be better
        # to delete the text instead, since the user asked for it.
        # There are two bits of information in the event; the position
        # and the length. I think we could easily clear the text based
        # on this information, but for now I'll keep it just displaying
        # the previously hidden text. --pkm 2006-04-04.
        o = evt.GetEventObject()
        position = evt.GetPosition()
        ## length = evt.GetLength()
        line = o.LineFromPosition(position)
        o.Expand(line, True)

    def OnKeyPressed(self, event):
        keyAt = event.KeyCode()
        blControlDownAt = event.ControlDown()   # Returns True if the Control key was down 
        if blControlDownAt:
            if keyAt == ord('E'):               # 07.01.14 hardcode diamond carsor
                #pdb.Pdb().set_trace()
                self.LineUp()
                return;
            elif keyAt == ord('X'):
                self.LineDown()
                return True;
            elif keyAt == ord('D'):
                self.CharRight()
                return;
            elif keyAt == ord('S'):
                self.CharLeft()
                return;
            elif keyAt == ord('F'):
                self.WordRight()
                return;
            elif keyAt == ord('A'):
                self.WordLeft()
                return;
            elif keyAt == ord('R'):
                self.PageUp()
                return;
            elif keyAt == ord('C'):
                self.PageDown()
                return;

        """
        if keyAt == ord('F'):                   # to dubg
            pdb.Pdb().set_trace()
        print "debug AltDown():", event.AltDown()
        print "debug keyAt:", keyAt
        print "debug m_x:", event.m_x
        print "debug m_y:", event.m_y
        """
        event.Skip()


#------------ Test Other Main Windows begin ----------------------------------
frame = None
#class kVzFrame(wx.Frame):
class Cl_kVzBase(wx.Frame):
    def __init__(self, configAg, title):
        wx.Frame.__init__(self, None ,-1, title, size = ( 600, 400 ),
                         style=wx.DEFAULT_FRAME_STYLE|wx.NO_FULL_REPAINT_ON_RESIZE)
        self.SetIcon(getIcon())

        from plugins import single_instance
        single_instance.callback = self.OnDrop

        global menuBar
        menuBar = wxMenuBar()

        self.SetMenuBar(menuBar)  # Adding the MenuBar to the Frame content.
        self.menubar = menuBar

        self.config = configAg
        if ( 'LASTSIZE') in self.config:
            self.SetSize(self.config['LASTSIZE'])
        else:
            self.SetSize( (640,400) )
        if ( 'LASTPOSITION') in self.config:
            self.SetPosition(self.config['LASTPOSITION'])
        else:
            self.SetPosition( (0,0) )

#----------------- Adds opened file history to the File menu -----------------
        if True:                                #kVz 06.12.27
            self.fileHistory = wx.FileHistory() #kVz 06.12.27
            self.curdocstates = {}              #kVz 06.12.28

#------------------------ A ...few... state variables ------------------------
        if True:
            self.openfiles = {}
            self.realfn = {}

#--------------------------------- File Menu ---------------------------------
        filemenu= wxMenu()
        menuAddM(menuBar, filemenu, "&File")
        menuAdd(self, filemenu, "&New",         "New file", self.OnNew, wxID_NEW)
        menuAdd(self, filemenu, "&Open",        "Open a file", self.OnOpen, wxID_OPEN)
        menuAdd(self, filemenu, "Open &Module\tAlt+M",  "Open a module for editing using the same path search as import would", self.OnOpenModule, wxNewId())
        menuAdd(self, filemenu, "Open &Last\t",         "Open all the documents that were opening before last program exit", self.OnOpenPrevDocs, wxNewId())
        # recent menu relocated to load configuration early on.
        recentmenu = wxMenu()
        menuAddM(filemenu, recentmenu, "Open Recent")
        filemenu.AppendSeparator()
        menuAdd(self, filemenu, "&Save\tAlt+S",        "Save a file", self.OnSave, wxID_SAVE)
        menuAdd(self, filemenu, "Save &As",             "Save a file as...", self.OnSaveAs, wxID_SAVEAS)
        menuAdd(self, filemenu, "Sa&ve All",            "Save all open files...", self.OnSaveAll, wxNewId())
        """
        filemenu.AppendSeparator()
        menuAdd(self, filemenu, "New &Python Shell",     "Opens a Python shell in a new tab", self.OnNewPythonShell, wxNewId())
        menuAdd(self, filemenu, "New &Command Shell",    "Opens a command line shell in a new tab", self.OnNewCommandShell, wxNewId())
        filemenu.AppendSeparator()
        menuAdd(self, filemenu, "Add Module Search Path", "Add a path to search during subsequent 'Open Module' executions", self.AddSearchPath, wxNewId())
        menuAdd(self, filemenu, "&Reload",              "Reload the current document from disk", self.OnReload, wxID_REVERT)
        menuAdd(self, filemenu, "&Close\tCtrl+W",       "Close the file in this tab", self.OnClose, wxNewId())
        workspace.WorkspaceMenu(filemenu, self, workspaces, workspace_order)
        menuAdd(self, filemenu, "Restart",              "Restart PyPE", self.OnRestart, wxNewId())
        """
        menuAdd(self, filemenu, "E&xit\tAlt+F4",        "Terminate the program", self.OnExit, wxNewId())


        #pdb.Pdb().set_trace()
        # 07.01.22 mouse ł t@C  drag and drop ̂߂ɉKvł
        self.SetDropTarget(FileDropTarget(self))

        # Key Operation ֐̓o^
        #wx.EVT_KEY_DOWN(self, self.OnKeyPressed)

        self.sb = wx.StatusBar(self, -1)
        self.sb.SetFieldsCount(3)
        self.sb.SetStatusWidths([-1, 95, 60])   # unicode
        #self.sb.SetStatusWidths([-1, 95])  # ASCII
        self.SetStatusBar(self.sb)
        self._setupToolBar()
        #self.FINDSHOWN = 0


        """'
        #pdb.Pdb().set_trace()

        # class PythonSTC::def __init__(self, notebook, ID, parent):
        self.m_winEditor = PythonSTC(self, wxNewId(), self)
        #nwinAt = interpreter.MyShell(self, wxNewId(), self, None, 1)   # Python Shell ɂȂ

        from StyleSetter import initSTC     # PyPES\StyleSetter.py  initSTC Ă
        initSTC(self.m_winEditor, cf.stylefile, '')

        #stc.StyledTextCtrl(self, wx.NewId(), style = wx.NO_FULL_REPAINT_ON_RESIZE)
        #nwin = PythonSTC(self, wxNewId())
        '"""

        #path = os.path.join(homedir, 'menus.txt')
        #print "--- test ----"
        #print path
        #print "debug help(wx.Frame):", help(wx.Frame)
        #print "debug help(wx.Frame.SetTitle):", help(wx.Frame.SetTitle)

    def _setupToolBar(self):
        size = (16,16)
        def getBmp(artId, client):
            bmp = wx.ArtProvider_GetBitmap(artId, client, size)
            if not bmp.Ok():
                bmp = EmptyBitmap(*size)
            return bmp
        
        orient = wx.TB_HORIZONTAL
        tb = self.CreateToolBar(
            orient|wx.NO_BORDER|wx.TB_FLAT|wx.TB_TEXT)
        
        tb.SetToolBitmapSize(size)
        
        icon = getBmp(wx.ART_NORMAL_FILE, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_NEW, icon, "New Document",
            "Create a new empty document")
        icon = getBmp(wx.ART_FILE_OPEN, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_OPEN, icon, "Open",
            "Open an existing document")
        icon = getBmp(wx.ART_FILE_SAVE, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_SAVE, icon, "Save", "Save current document")
        
        icon = getBmp(wx.ART_FILE_SAVE_AS, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_SAVEAS, icon, "Save as...", "Save current document as...")

        tb.AddSeparator()

        icon = getBmp(wx.ART_CUT, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_CUT, icon, "Cut",
            "Cut selection to the clibboard")
        icon = getBmp(wx.ART_COPY, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_COPY, icon, "Copy",
            "Copy selection to the clibboard")
        icon = getBmp(wx.ART_PASTE, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_PASTE, icon, "Paste",
            "Paste current clibboard contents")
        icon = getBmp(wx.ART_DELETE, wx.ART_TOOLBAR)
        tb.AddSimpleTool(pypeID_DELETE, icon, "Delete",
            "Delete selection")

        tb.AddSeparator()

        icon = getBmp(wx.ART_UNDO, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_UNDO, icon, "Undo",
            "Undo edit")
        icon = getBmp(wx.ART_REDO, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_REDO, icon, "Redo",
            "Redo edit (i.e. undo undo edit)")

        tb.AddSeparator()

        icon = getBmp(wx.ART_FIND, wx.ART_TOOLBAR)
        tb.AddSimpleTool(pypeID_FINDBAR, icon, "Find",
            "Find")
        icon = getBmp(wx.ART_FIND_AND_REPLACE, wx.ART_TOOLBAR)
        tb.AddSimpleTool(pypeID_REPLACEBAR, icon, "Replace",
            "Find and replace")

        tb.AddSeparator()

        icon = getBmp(wx.ART_ADD_BOOKMARK, wx.ART_TOOLBAR)
        tb.AddSimpleTool(pypeID_TOGGLE_BOOKMARK, icon, "Toggle Bookmark",
            "Create or Remove a bookmark at the current line")
        
        icon = getBmp(wx.ART_GO_DOWN, wx.ART_TOOLBAR)
        tb.AddSimpleTool(pypeID_NEXT_BOOKMARK, icon, "Next Bookmark",
            "Go to the next bookmark in this file")

        icon = getBmp(wx.ART_GO_UP, wx.ART_TOOLBAR)
        tb.AddSimpleTool(pypeID_PRIOR_BOOKMARK, icon, "Previous Bookmark",
            "Go to the previous bookmark in this file")
        
        tb.AddSeparator()
        tb.AddSeparator()
        
        icon = getBmp(wx.ART_HELP, wx.ART_TOOLBAR)
        tb.AddSimpleTool(wx.ID_HELP, icon, "Help!",
            "Opens up the help for PyPE")
        
        tb.Realize()

    def OnNew(self,e):pass

    def OnSave(self,e):
        #pdb.Pdb().set_trace()
        # wnum, win = self.getNumWin(e) #kVz 06.12.27
        if self.m_winEditor.dirname:    # if win.dirname: kVZ 06.12.27
            try:
                txt = self.m_winEditor.GetText() #kVz 06.12.27
                ofn = os.path.join(self.m_winEditor.dirname, #kVZ 06.12.27
                        self.m_winEditor.filename)           #kVZ 06.12.27
                fil = open(ofn, 'wb')
                fil.write(txt)
                fil.close()
                if UNICODE: a = "%s as %s"%(ofn, self.m_winEditor.enc) #kVz 06.12.27
                else:       a = ofn
                self.m_winEditor.mod = os.stat(ofn)[8]  # 06.12.27
                self.SetStatusText("Correctly saved %s"%a)
                self.curdocstates[ofn] = self.m_winEditor.GetSaveState() # kVz 06.12.27
                self.m_winEditor.MakeClean()            # 06.12.27
            except cancelled:
                raise
            except:
                self.exceptDialog("Save Failed")
                raise cancelled
        else:
            self.OnSaveAs(e)

    def OnSaveAs(self,e):
        #import pdb; pdb.set_trace()
        #wnum, win = self.getNumWin(e)

        dlg = wxFileDialog(self, "Save file as...", os.getcwd(), "", "All files (*.*)|*.*", wxSAVE|wxOVERWRITE_PROMPT)
        rslt = dlg.ShowModal()
        if rslt == wxID_OK:
            fn=dlg.GetFilename()
            dn=dlg.GetDirectory()
            if sys.platform == 'win32' and dn[1:] == ':':
                dn += '\\'
            
            pth = self.getAlmostAbsolute(fn, dn)
            dn, fn = os.path.split(pth)

            if self.m_winEditor.filename != fn or self.m_winEditor.dirname != dn:
                if self.isOpen(fn, dn):
                    self.dialog("Another file with that name and path is already open.\nSave aborted to prevent data corruption.", "Save Aborted!")
                    raise cancelled
                if self.isOpen(self.m_winEditor.filename, self.m_winEditor.dirname):
                    self.closeOpen(self.m_winEditor.filename, self.m_winEditor.dirname)
            
            #we do a quick GetText to make sure we don't set the file/dir names
            #unless we really can get the text for the file.
            x = self.m_winEditor.GetText()
            
            self.m_winEditor.filename = fn
            self.m_winEditor.dirname = dn
            self.makeOpen(fn, dn)
            self.fileHistory.AddFileToHistory(pth)
            self.OnSave(e)

            #fix the icons and names.
            #self.dragger._RemoveItem(wnum)
            #self.dragger._InsertItem(wnum, fn)

            self.m_winEditor.MakeDirtyKvz()
            self.m_winEditor.MakeClean()

        else:
            raise cancelled

    def OnSaveAll(self, e):
        sel = self.control.GetSelection()
        cnt = self.control.GetPageCount()
        for i in xrange(cnt):
            self.control.SetSelection(i)
            try:
                self.OnSave(e)
            except cancelled:
                pass
        if cnt:
            self.control.SetSelection(sel)

    def getAbsolute(self, fn, dn):
        return os.path.normcase(os.path.normpath(os.path.realpath(os.path.join(dn, fn))))
    def isOpen(self, fn, dn):
        return dn and fn and (self.getAbsolute(fn, dn) in self.openfiles)
    def getAlmostAbsolute(self, fn, dn):
        return os.path.normpath(os.path.realpath(os.path.join(dn, fn)))
    def splitAbsolute(self, path):
        return os.path.split(os.path.normcase(path))
    def makeOpen(self, fn, dn):
        if fn and dn:
            a = self.getAbsolute(fn, dn)
            self.openfiles[a] = self.splitAbsolute(a)
            self.realfn[a] = self.getAlmostAbsolute(fn, dn)
    def closeOpen(self, fn, dn):
        if fn and dn:
            a = self.getAbsolute(fn, dn)
            del self.openfiles[a]
            del self.realfn[a]
    def exceptDialog(self, title="Error"):
        k = cStringIO.StringIO()
        traceback.print_exc(file=k)
        k.seek(0)
        dlg = wxScrolledMessageDialog(self, k.read(), title)
        dlg.ShowModal()
        dlg.Destroy()
    def OnDrop(self, fnames, error=1):
        cwd = os.getcwd()
        for i in fnames:
            dn, fn = os.path.split(self.getAlmostAbsolute(i, cwd))
            if self.isOpen(fn, dn):
                if len(fnames)==1:
                    self.selectAbsolute(self.getAbsolute(fn, dn))
            else:
                FNAt = self.getAlmostAbsolute(fn, dn)
                fAt = open(FNAt, 'rb')
                txtAt = fAt.read()
                fAt.close()
                self.m_winEditor.format = detectLineEndings(txtAt)
                self.m_winEditor.SetText(txtAt)

                # kVz 06.12.28 begin
                RESET = {'cursorposn':0, 'BM':[], 'FOLD':[] }
                #pdb.Pdb().set_trace()
                ftypeAt = cf.extns.get(fn.split('.')[-1].lower(), 'python')
                # document_defaults  ftypeAt L[̒loBꂪȂƂ
                # DOCUMENT_DEFAULTS ̒lɂB̒l stateAt ɐݒ肷
                stateAt = dict(document_defaults.get(ftypeAt, DOCUMENT_DEFAULTS))
                #stateAt.update(RESET)
                self.m_winEditor.SetSaveState(stateAt)
                # kVz 06.12.28 end

                """'
                self.makeOpen(fn, dn)
                try:
                    a = self.newTab(dn, fn, len(fnames)==1)
                    i = os.path.join(dn, fn)
                    if UNICODE: a = "%s as %s"%(i, a)
                    else:       a = i
                    self.SetStatusText("Opened %s"%a)
                except:
                    self.closeOpen(fn, dn)
                    if error:
                        self.exceptDialog("File open failed")
                '"""
        #self.redrawvisible()

    def OnOpen(self,e):
        wd = self.config.get('lastpath', os.getcwd())
        dlg = wxFileDialog(self, "Choose a/some file(s)...", wd, "", cf.wildcard, wxOPEN|wxMULTIPLE|wxHIDE_READONLY)
        if dlg.ShowModal() == wxID_OK:
            #import pdb; pdb.set_trace()
            self.OnDrop(dlg.GetPaths())
            self.config['lp'] = dlg.GetDirectory()
        dlg.Destroy()

    def OnOpenModule(self,e):
        # python module J 07.01.22
        # self.config['modulepaths']  path ǉ邱ƂŁApython path L
        # py file T܂
        dlg = wxTextEntryDialog(self, 'Enter the module name you would like to open', 'Open module...')
        if dlg.ShowModal() == wxID_OK:
            mod = dlg.GetValue()
        else:
            mod = ''
        dlg.Destroy()
        if mod:
            sp = sys.path[:]
            sys.path.extend(self.config['modulepaths'])
            try:
                self.OnDrop([self.FindModule(mod)])
            except:
                self.dialog("module %s not found"%mod, "not found")
            sys.path = sp

    def OnOpenPrevDocs(self, e):
        if "lastopen" in self.config:
            self.OnDrop(self.config['lastopen'], 1)



    def OnExit(self,e):
        """'
        if self.closing:
            return e.Skip()
        self.closing = 1
        if USE_THREAD:
            parse_queue.put(None)
        sel = self.control.GetSelection()
        cnt = self.control.GetPageCount()
        try:
            for i in xrange(cnt):
                win = self.control.GetPage(i).GetWindow1()

                if isdirty(win):
                    self.control.SetSelection(i)
                    self.sharedsave(win)
                else:
                    self.curdocstates[self.getAlmostAbsolute(win.filename, win.dirname)] = win.GetSaveState()
        except cancelled:
            self.closing = 0
            try:    return e.Veto()
            except: return e.Skip()

        self.saveHistory()
        if sel > -1:
            self.control.SetSelection(sel)
        '"""
        self.saveHistory()
        return self.Close(True)


    def readAndEvalFile(self, filename):
        f = open(filename)
        txt = f.read().replace('\r\n','\n')
        f.close()
        return eval(txt)

#----------------------------- File Menu Methods ------- kVz 06.12.28
    def getPositionAbsolute(self, path, newf=0):
        ## print path
        path = os.path.normcase(path)
        dn, fn = self.splitAbsolute(path)
        if newf:
            try:
                v = int(fn[10:-1])
            except:
                return -1
        for i in xrange(self.control.GetPageCount()):
            win = self.control.GetPage(i).GetWindow1()
            if newf:
                if not win.dirname and v == win.NEWDOCUMENT:
                    return i
            elif path == self.getAbsolute(win.filename, win.dirname):
                return i

        return -1
#------------------------------ others -----------------------
    #"""'
    def OnIdle(self, eventAg):
        #eventAg.RequestMore(True)
        #pdb.Pdb().set_trace()
        #if not vf.ClVrfySglt.GetStt().isEnded():  #  actionScripts t@C̂ƂgȂ
        if not clTestGlb.m_pClVrfyIntfBase.IsEnded():
            vf.ClVrfySglt.GetStt().VrfyLoop()
    #'"""
    def postKeyEvent(self, strAg):
        #pdb.Pdb().set_trace()
        if strAg == "alt":
            evAt = wx.KeyEvent(eventType=wx.wxEVT_KEY_DOWN)
            evAt.m_altDown = True
            evAt.m_keyCode = wx.WXK_ALT
            wx.PostEvent(self, evAt)
        elif strAg == "F":
            evAt = wx.KeyEvent(eventType=wx.wxEVT_KEY_DOWN)
            #evAt = wx.KeyEvent(eventType=wx.wxEVT_CHAR)
            evAt.m_altDown = True
            evAt.m_controlDown = False
            evAt.m_metalDown = False
            evAt.m_scanCode = False
            evAt.m_shiftDown = False
            evAt.m_keyCode = ord('F')
            evAt.m_rawCode = ord('F')
            evAt.m_rawFlags = 539033601
            evAt.m_x = 39
            evAt.m_y = 363
            wx.PostEvent(self, evAt)
            #wx.PostEvent(appGb, evAt)
        """
        elif strAg == "O":
            evAt = wx.KeyEvent(eventType=wx.wxEVT_KEY_DOWN)
            #evAt = wx.KeyEvent(eventType=wx.wxEVT_CHAR)
            evAt.m_altDown = True
            evAt.m_keyCode = ord('O')
            wx.PostEvent(self, evAt)
        """
# 07.01.22 mouse ł t@C  drag and drop ̂߂ɉKvł
class FileDropTarget(wx.FileDropTarget):
    def __init__(self, root):
        wx.FileDropTarget.__init__(self)
        self.root = root
    def OnDropFiles(self, x, y, filenames):
        self.root.OnDrop(filenames)

import vrfyActn as vf
#app = None
appGb = None

import win32api as wa
import win32con as wc
def postKeyEvent(strAg):
    #pdb.Pdb().set_trace()
    appGb.frame.postKeyEvent(strAg)

def call_keybd_event(strAg):
    """win32api keybd_event(.) Ăяo܂
    :strAg ͐K\:(VK_\w+:\x20+)*[A-Z_]+ Ƀ}b`˂΂Ȃ܂B
    KvȂƂ VK_\w+ ɉzL[Lq܂B
    \S+ ɑ荞݂ ASCII/Shift JIS Lq܂
    <== space tab  \x20, \x09 ő荞ޗ\łB(܂)

    """
    #pdb.Pdb().set_trace()
    lstStrAt = strAg.split()
    lstVkCode = []
    for strAt in lstStrAt:
        if (strAt[0:3] == "VK_") and (strAt[-1] == ":"):
            codeAt = eval("wc." + strAt[0:-1])
            lstVkCode.append(codeAt)
            wa.keybd_event( codeAt, 0) # generate VK_??? down event
        elif (strAt[0:2] == r"\x"):
            strAt = '0' + strAt[1:]
            wa.keybd_event( eval(strAt), 0)   # default key down event
            wa.keybd_event( eval(strAt), 0, wc.KEYEVENTF_KEYUP)
        
        else:
            for chAt in strAt:
                wa.keybd_event( ord(chAt.upper()), 0)   # default key down event
                wa.keybd_event( ord(chAt.upper()), 0, wc.KEYEVENTF_KEYUP)

    for codeAt in lstVkCode:
        wa.keybd_event( codeAt, 0, wc.KEYEVENTF_KEYUP)

class Cl_kVzEditor(Cl_kVzBase):
    def __init__(self, strPath_fileNameAg):
        Cl_kVzBase.__init__(self, "configEditor.ini", strPath_fileNameAg)

        #pdb.Pdb().set_trace()

        # class PythonSTC::def __init__(self, notebook, ID, parent):
        self.m_winEditor = PythonSTC(self, wxNewId(), self)
        #nwinAt = interpreter.MyShell(self, wxNewId(), self, None, 1)   # Python Shell ɂȂ

        from StyleSetter import initSTC     # PyPES\StyleSetter.py  initSTC Ă
        initSTC(self.m_winEditor, cf.stylefile, '')

        #stc.StyledTextCtrl(self, wx.NewId(), style = wx.NO_FULL_REPAINT_ON_RESIZE)
        #nwin = PythonSTC(self, wxNewId())

    def saveHistory(self):
        # 07.03.27 coding lefted
        pass

class Cl_kVzShell(Cl_kVzBase):
    def __init__(self, strDirPathOrFileAg):
        Cl_kVzBase.__init__(self, strDirPathOrFileAg, "kVz Shell")
        self.loadHistory()
        if os.path.isdir(strDirPathOrFileAg):
            self.m_strAbsolutePathOfConfigFile = os.path.abspath(strDirPathOrFileAg)
            self.m_strConfigFile = "configShell.ini"
        elif os.path.isfile(strDirPathOrFileAg):
            self.m_strAbsolutePathOfConfigFile, self.m_strConfigFile = os.path.splie(
                    os.path.abspath(strDirPathOrFileAg) )
        else:
            pass    # { error raise
        

    def showFrame(self,strDirPathAg):
        Cl_kVzBase.__init__(self, self.config, strDirPathAg)

        #pdb.Pdb().set_trace()

        # Ō̈ 1 ɂ python shell ɂȂ
        #from plugins import interpreter
        #nwinAt = interpreter.MyShell(self, wxNewId(), self, None, 0)
        #import plugins.interpreter as intr
        import plugins.interpreter2 as intr
        self.m_winShell = intr.MyShell(self, wxNewId(), self, None, 0)
        #nwinAt = interpreter.MyShell(self, wxNewId(), self, None, 1)   # Python Shell ɂȂ

        from StyleSetter import initSTC     # PyPES\StyleSetter.py  initSTC Ă
        initSTC(self.m_winShell, cf.stylefile, '')

    def loadHistory(self):
        """'
        if not os.path.exists(self.configPath):
            os.mkdir(self.configPath)
        path = os.path.join(self.configPath, 'history.txt')
        if UNICODE:
            p = os.path.join(self.configPath, 'history.u.txt')
            if os.path.exists(p):
                path = p
        '"""
        path = "configEditor.ini"
        print "Loading history from", path
        try:    self.config = self.readAndEvalFile(path)
        except: self.config = {}
        #"""'
        if 'history' in self.config:
            history = self.config['history']
            history.reverse()
            for h in history:
                self.fileHistory.AddFileToHistory(h)
        if 'lastpath' in self.config:
            self.lastpath = self.config['lastpath']

        doc_def = {}
        #insert global document defaults here
        dct =     {'use_tabs':0,
             'spaces_per_tab':8,
                     'indent':4,
                   'collapse':1,
              'marker_margin':1,
                'line_margin':1,
                   'col_line':78,
                   'col_mode':wxSTC_EDGE_LINE,
               'indent_guide':0,
               'showautocomp':0,
                   'wrapmode':wxSTC_WRAP_NONE,
                   'sortmode':1,
                'save_cursor':0,
                'cursor_posn':0,
                 'whitespace':0,
                   'triggers':{},
               'findbarprefs':{},
                     'sloppy':0,
                 'smartpaste':0}
        #for _i in ASSOC:                   kVz 06.12.27
        #    doc_def[_i[2]] = dict(dct)     kVZ 06.12.27
        # import pdb; pdb.set_trace()
        for (nam, dflt) in [('modulepaths', []),    # globals() ɕϐǉ
                            ## ('usesnippets', 0),
                            ## ('usetodo', 0),
                            ## ('paths', {}),
                            ## ('display2code', {}),
                            ## ('displayorder', []),
                            ## ('shellcommands', []),
                            ('lastopen', []),
                            #('LASTUSED', []),      # 07.02.05 
                            ('DEFAULTLEXER', 'python'),
                            #('FIF_STATE', ([], [], [], 0, 0, 0)),  # 07.02.05 
                            #('match_flags', wxFR_DOWN),            # 07.02.16 
                            ('pathmarksn', []),
                            ('workspaces', {}),
                            ('workspace_order', []),
                            #('SASH1', 60),     # 07.02.05 
                            #('SASH2', 300),    # 07.02.05 
                            ('LASTSIZE', (900,600)),
                            ('LASTPOSITION', self.GetPositionTuple()),
                            ('logbarlocn', 1),
                            #('docbarlocn', 1), # 07.02.05 
                            # ('dnd_file', 1),  # 07.02.05 
                            ('caret_option', 0),
                            ('caret_slop', 10),
                            ('caret_multiplier', 20),
                            ('findbarprefs', {}),
                            ('no_findbar_history', 0),
                            ('title_option', 0),
                            ('document_defaults', doc_def),
                            ('DOCUMENT_DEFAULTS', dct),
                            ('TODOBOTTOM', 1),
                            ('TOOLBAR', 0),
                            # ('SHOWWIDE', 1),  # 07.02.05 
                            # ('SHOWTALL', 1),  # 07.02.05 
                            ('shellprefs', {}),
                            ('findbar_location', 1),
                            ('single_pype_instance', 0),
                            ('DICTIONARIES', {}),
                            ('USE_DOC_ICONS', 1),
                            ('CARET_WIDTH', 1),
                            #('ONE_TAB_', 1),       # 07.02.05 
                            ]:
            if nam in self.config:
                if isinstance(dflt, dict):
                    for k,v in dflt.iteritems():
                        if k not in self.config[nam]:
                            if isinstance(v, dict):
                                self.config[nam][k] = dict(v)
                            else:
                                self.config[nam][k] = v
                        elif isinstance(v, dict):
                            V = self.config[nam][k]
                            for k2,v2 in v.iteritems():
                                if k2 not in V:
                                    V[k2] = v2
            elif isinstance(dflt, dict):
                self.config[nam] = dict(dflt)
            else:
                self.config[nam] = dflt
            globals()[nam] = self.config[nam]
        globals().update(dct)
        globals().update(self.config.setdefault('DOCUMENT_DEFAULTS', dct))
        #'"""

    def saveHistory(self):
        #pdb.Pdb().set_trace()
        """'
        LASTOPEN = []
        sav = []
        for win in self.control:
            if win.dirname:
                sav.append(self.getAlmostAbsolute(win.filename, win.dirname))
                LASTOPEN.append((self.getAlmostAbsolute(win.filename, win.dirname), win.GetSaveState()))


        if 'LASTOPEN' in self.config:
            del self.config['LASTOPEN']
        '"""
        #saving document state
        self.config['LASTSIZE'] = self.GetSizeTuple()
        self.config['LASTPOSITION'] = self.GetPositionTuple()
        
        """'
        self.config['LASTPOSITION'] = self.GetPositionTuple()
        # self.config['SASH1'] = self.BOTTOM.GetSizeTuple()[1]  # 07.02.05 
        # self.config['SASH2'] = self.RIGHT.GetSizeTuple()[0]   # 07.02.05 
        
        history = []
        for i in range(self.fileHistory.GetNoHistoryFiles()):
            history.append(self.fileHistory.GetHistoryFile(i))
        self.config['history'] = history
        ## a = []
        ## for i in self.shell.order:
            ## a.append(self.shell.menu[i])
        ## self.config['shellcommands'] = a
        #self.config['match_flags'] = match_flags               # 07.02.16 
        self.config['pathmarksn'] = self.pathmarks.op.GetLabels()
        self.config['workspaces'] = workspaces
        self.config['workspace_order'] = workspace_order
        self.config['logbarlocn'] = logbarlocn
        # self.config['docbarlocn'] = docbarlocn    # 07.02.05 
        # self.config['dnd_file'] = dnd_file    # 07.02.05 
        self.config['caret_option'] = caret_option
        self.config['caret_slop'] = caret_slop
        self.config['caret_multiplier'] = caret_multiplier
        self.config['findbarprefs'] = findbarprefs
        self.config['no_findbar_history'] = no_findbar_history
        self.config['title_option'] = title_option
        self.config['TODOBOTTOM'] = TODOBOTTOM
        self.config['single_pype_instance'] = single_pype_instance
        self.config['TOOLBAR'] = TOOLBAR
        # self.config['SHOWWIDE'] = SHOWWIDE    # 07.02.05 
        #self.config['SHOWTALL'] = SHOWTALL # 07.02.05 
        self.config['USE_DOC_ICONS'] = USE_DOC_ICONS
        ## self.config['shellprefs'] = self.shell.save_prefs()
        self.config['findbar_location'] = findbar_location
        ## if self.config['usesnippets'] and (not self.restart):
            ## self.config['display2code'] = self.snippet.display2code
            ## self.config['displayorder'] = self.snippet.displayorder
        self.config['lastpath'] = self.config.get('lp', os.getcwd())
        self.config['CARET_WIDTH'] = CARET_WIDTH
        # self.config['ONE_TAB_'] = ONE_TAB_    # 07.02.05 
        '"""
        #pdb.Pdb().set_trace()
        try:
            path = "configEditor.ini"
            print "Saving history to", path
            f = open(path, "w")
            f.write(pprint.pformat(self.config))
            f.close()
            """
            if UNICODE:
                path = os.sep.join([self.configPath, 'menus.u.txt'])
            else:
                path = os.sep.join([self.configPath, 'menus.txt'])
            print "Saving menus to", path
            f = open(path, "w")
            f.write(pprint.pformat(MENUPREF))
            f.close()
            """
        except:
            self.exceptDialog("Could not save preferences to %s"%path)



class ClTest(vf.ClVfLibActn):
    def kvDoAtInitial(self, crFileNameAg):
        if ( ( crFileNameAg == 'testEdtr.vrf')
          or ( crFileNameAg == 'test.vrf')
        ):
            #pdb.Pdb().set_trace()
            vf.ClVfLibActn.kvDoAtInitial(self, crFileNameAg)

            #self.RgstVerified( vf.ClVrfyFncVar('postKeyEvent') )
            self.RgstVerified( vf.ClVrfyFncVar(
                'appGb.frame.postKeyEvent'
               , actnScrptNameAg = 'postKeyEvent') )

            self.RgstVerified( vf.ClVrfyFncVar(
                'call_keybd_event'
               , actnScrptNameAg = 'keybd_event') )

clTestGlb = ClTest(globals())

# 07.01.17 PySimpleApp p idling loop ׂłBFrame Ăׂł͂܂B
# ł̃R[hł ProcessIdle(.) ĂяoĂ܂B
# findstr /n /s ProcessIdle C:\lng\python24\*.py ŒTĂ ProcessIdle(.) ĂяoĂ܂
# Ƃ肠߂ Frame ł idling ɖ߂܂
class MyApp(wx.PySimpleApp):
    def __init__(self):
        wx.PySimpleApp.__init__(self)
    
    def ProcessIdle(self, evAg):
        #pdb.Pdb().set_trace()
        #blReturnAt = wx.PySimpleApp.ProcessIdle(self)

        #if not vf.ClVrfySglt.GetStt().isEnded():  #  actionScripts t@C̂ƂgȂ
        if not clTestGlb.m_pClVrfyIntfBase.IsEnded():
            vf.ClVrfySglt.GetStt().VrfyLoop()

        evAg.Skip()
        #return blReturnAt

    def analyzeOption(self):
        import optparse as op
        opAt = op.OptionParser()
    
        opAt.add_option("-d", "--dir",
                action="store", dest="m_strDir",
                help="config.ini and shell directory" )
    
        opAt.add_option("-c", "--crnt",
                action="store_true", dest="m_blCurrent",
                default=False,
                help="default config.ini and shell directory: that is kVz directory" )

        opAt.add_option("-f", "--file",
                action="store", dest="m_strFile",
                help="File Editor Only flag" )
    
        opAt.add_option("-a", "--act",
                action="store", dest="m_strVerify",
                help="action script file" )
    
        opAt.add_option(      "--ver",
                action="store_false", dest="m_strVesion",
                help="print kVz.py version" )
    
    
        self.m_clOption, self.m_lstStrFiles = opAt.parse_args()

        if (self.m_clOption.m_blCurrent == True):
            # R}h𔭍sꏊ̃JgEfBNgɂȂB
            self.m_clOption.m_strDir = os.getcwd()

        if (self.m_clOption.m_strDir == None) and (
            self.m_clOption.m_blCurrent == False):
            self.m_clOption.m_strDir = ".\\"

def main():
    global appGb
    #print "debug homedir:", homedir
    #appGb = wx.PySimpleApp()


    try:
        appGb = MyApp()
        #import pdb; pdb.Pdb().set_trace()
        appGb.analyzeOption()
    
        """'
        '"""
        import pdb; pdb.Pdb().set_trace()
        appGb.frame = Cl_kVzShell("kVzShell")
        if not (appGb.m_clOption.m_strDir == None):
            appGb.frame.showFrame("kVzShellX")
            appGb.frame.Show()
    
        if not (appGb.m_lstStrFiles == None):
            appGb.frame2 = Cl_kVzEditor("kVzEditor")
            appGb.frame2.Show()
        """
        """
        #app.frame = wx.Frame(None, title='Hello World')
        #app.SetTopWindow(app.frame) # ȗ͂ł wxPySimpleApp gĂ邩
        
        #pdb.Pdb().set_trace()
        if not (appGb.m_clOption.m_strVerify == None):
            vf.ClVrfySglt.GetStt().Initialize(2, [ None, appGb.m_clOption.m_strVerify ] )
            #wx.EVT_IDLE(appGb.frame, appGb.frame.OnIdle)
            wx.EVT_IDLE(appGb, appGb.ProcessIdle)
        
        #appGb.frame.Show()
        appGb.MainLoop()

    except:
        print sys.exc_type
        

if __name__ == '__main__':
    main()

#------------ Test Other Main Windows end ----------------------------------

